﻿from pandas.io.parsers import read_csv
import matplotlib.pyplot as plt
import numpy as np
# scipy
from scipy.fftpack import fft, ifft
# scikit-learn
from sklearn.cluster import KMeans as skc_km
from sklearn.cluster import AffinityPropagation as skc_ap
from sklearn.cluster import SpectralClustering as skc_sc

import math
import sys
import simres as sim

def save_result(x):
    file = open("result.txt",'w')
    for i in range(0,sampleCount):
        file.write(str(x[i])+'\n')
    file.close()

if __name__ == "__main__":
    #----------------------------------------------
    # select clustering method
    #----------------------------------------------
    useAF = False
    useKM = False
    useSC = False
    #
    useSC = True
    #----------------------------------------------
    # SET TARGET cluster number
    #----------------------------------------------    
    classCount = 6
    ret = sim.load_result(r'E:\your\model\MRSRESULT\SPE9.SMSPEC','m','s')
    
    sn = sim.sm_getn_wells()
    #print(sn)
    sampleCount = len(sn)
    vn = "WWCT"
    inlist = []
    for i in range(0,len(sn)):
        vv = sim.sm_getv_well(sn[i],vn)
        #print(vv)
        inlist.append(vv)
    input = np.array(inlist)
    #print(input.shape)
    #sys.exit()
    #exit
    #print(input)

    #----------------------------------------------
    #  data is ready, do something!
    #----------------------------------------------
    if useKM == True:
        print("KMeans")
        sc_result = skc_km(n_clusters=classCount, random_state=0).fit(input)
        #print(sc_result.cluster_centers_)
    elif useAF == True:
        print("AffinityPropagation")
        sc_result = skc_ap().fit(input)
        #print the index of the center in input data
        #print(sc_result.cluster_centers_indices_)
    elif useSC == True:
        print("SpectralClustering")
        sc_result = skc_sc(n_clusters=classCount, random_state=0).fit(input)
        #print(sc_result.cluster_centers_)
    print(sc_result.labels_)
    
    fig = plt.figure()

    if 1 == 1:
        n = math.sqrt(classCount)
        if n > int(n):
            n = int(n) + 1
        else:
            n = int(n)
        x = sim.sm_getv_time()
        dataCount=len(x)
        #dataCount = len(df.iloc[0:1,1:].values[0])
        print(dataCount)
        plot_no = 1
        for i in range(0,classCount):
            print("Ploting class={0}".format(str(i)))
            print("------------------------------------------------")
            wno = 0
            for cl in sc_result.labels_:
                if cl == i:
                    plt.subplot(n,n,i+1)
                    y = inlist[wno]

                    print(sn[wno])
                    plt.plot(x,y,label=sn[wno])
                    plt.legend()
                wno = wno + 1
    #if useAF == True:
    #    ax2.plot(x, af_result.labels_, color='#00FF00', label='AffinityPropagation' )
    #final = skc_result.labels_ + sc_result.labels_ + af_result.labels_
    #ax2.plot(x, final, color='#000000')
    #plt.legend()
    plt.show()